## cctools 7.13.1

=== Makefile ===
include config.mk
# export all variables in config.mk
export

include rules.mk


CYGWINLIB = cygwin1.dll cyggcc_s-1.dll cygintl-8.dll cygreadline7.dll cygncursesw-10.dll cygiconv-2.dll cygattr-1.dll sh.exe

#set the default values for RPM_VERSION and RPM_RELEASE
RPM_VERSION=4.4.1
RPM_RELEASE=1

all: $(CCTOOLS_PACKAGES)

config.mk:
	@echo "You must run 'configure' before '${MAKE}'."
	@exit 1

batch_job chirp taskvine deltadb ftp_lite tlq makeflow makeflow_linker parrot resource_monitor work_queue grow: dttools
makeflow: batch_job
parrot: ftp_lite grow
batch_job parrot: chirp
batch_job makeflow: work_queue
batch_job makeflow: taskvine

clean-config:
	rm -f .configure.tmp.o cctools.test.log cctools.test.fail cctools.test.tmp configure.rerun

$(CCTOOLS_PACKAGES): config.mk
	@$(MAKE) -C $@

CLEAN_PACKAGES = $(CCTOOLS_PACKAGES:%=clean-%)
$(CLEAN_PACKAGES):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_PACKAGES) clean-config

INSTALL_PACKAGES = $(CCTOOLS_PACKAGES:%=install-%)
$(INSTALL_PACKAGES): $(CCTOOLS_PACKAGES)
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_PACKAGES)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	for file in $(CYGWINLIB) ; do if [ -f /bin/$$file ] ; then cp /bin/$$file $(CCTOOLS_INSTALL_DIR)/bin/ ; fi ; done
	mkdir -p ${CCTOOLS_INSTALL_DIR}/etc/cctools
	cp config.mk ${CCTOOLS_INSTALL_DIR}/etc/cctools
	mkdir -p ${CCTOOLS_INSTALL_DIR}/doc/cctools
	cp README.md COPYING CREDITS ${CCTOOLS_INSTALL_DIR}/doc/cctools

test: $(CCTOOLS_PACKAGES)
	./run_all_tests.sh

PACKAGES_TO_LINT = taskvine resource_monitor batch_job dttools poncho
LINT_PACKAGES = $(PACKAGES_TO_LINT:%=lint-%)
$(LINT_PACKAGES): config.mk
	@$(MAKE) -C $(@:lint-%=%) lint
lint: $(LINT_PACKAGES)

PACKAGES_TO_FORMAT = taskvine resource_monitor batch_job dttools
FORMAT_PACKAGES = $(PACKAGES_TO_FORMAT:%=format-%)
$(FORMAT_PACKAGES): config.mk
	@$(MAKE) -C $(@:format-%=%) format
format: $(FORMAT_PACKAGES)

rpm:
	./packaging/rpm/rpm_creator.sh $(RPM_VERSION) $(RPM_RELEASE)

.PHONY: $(CCTOOLS_PACKAGES) $(INSTALL_PACKAGES) $(CLEAN_PACKAGES) all clean install test lint rpm

=== batch_job/src/Makefile ===
include ../../config.mk
include ../../rules.mk

LIBRARIES = libbatch_job.a

PROGRAMS = work_queue_factory work_queue_pool vine_factory
SCRIPTS = condor_chaos_monkey

DT_LIB=${CCTOOLS_HOME}/dttools/src/libdttools.a
WQ_LIB=${CCTOOLS_HOME}/work_queue/src/libwork_queue.a
VINE_LIB=${CCTOOLS_HOME}/taskvine/src/manager/libtaskvine.a

EXTERNAL_LIBRARIES=$(CHIRP_LIB) $(DT_LIB)

SOURCES = \
	batch_queue.c \
	batch_job.c \
	batch_job_info.c \
	batch_file.c \
	batch_wrapper.c \
	batch_queue_local.c \
	batch_queue_dryrun.c \
	batch_queue_condor.c \
	batch_queue_vine.c \
	batch_queue_work_queue.c \
	batch_queue_cluster.c \
	batch_queue_k8s.c \
	batch_queue_amazon.c

PUBLIC_HEADERS = batch_queue.h batch_job.h batch_job_info.h batch_file.h batch_wrapper.h

OBJECTS = $(SOURCES:%.c=%.o)

all: $(LIBRARIES) $(PROGRAMS) $(SCRIPTS)

libbatch_job.a: $(OBJECTS)

work_queue_factory: work_queue_factory.o libbatch_job.a $(WQ_LIB) $(VINE_LIB) $(EXTERNAL_LIBRARIES)
vine_factory: vine_factory.o libbatch_job.a $(WQ_LIB) $(VINE_LIB) $(EXTERNAL_LIBRARIES)

# Note that work_queue_pool is the same as work_queue_factory, for backwards compatibility.
work_queue_pool: work_queue_factory
	cp $< $@

condor_chaos_monkey:
	chmod 755 condor_chaos_monkey

install:
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools

clean:
	rm -rf $(OBJECTS) $(LIBRARIES) $(PROGRAMS) *.o

lint:
	if ( ! clang-format -Werror --dry-run --style='file:../../.clang-format' $(SOURCES));\
	then\
		echo  "========================================================";\
		echo  "NOTICE: Run `make format` to format your latest changes.";\
		echo  "========================================================";\
		exit 1;\
	fi

format:
	clang-format -i $(SOURCES)

=== resource_monitor/src/Makefile ===
UNAME := $(shell uname)

SOURCES = \
    rminimonitor_helper.c \
    rmonitor_helper_comm.c \
    rmonitor_helper.c \
    rmonitor_snapshot.c \
    rmonitor_file_watch.c \
    rmonitor_poll_example.c \
    piggybacker.c \
    resource_monitor.c

include ../../config.mk
include ../../rules.mk

LIBRARIES = librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX) librminimonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX)
OBJECTS = resource_monitor_pb.o rmonitor_helper_comm.o resource_monitor.o rmonitor_helper.o rmonitor_file_watch.o

LOCAL_LINKAGE = ../../dttools/src/libdttools.a

PROGRAMS = resource_monitor piggybacker rmonitor_poll_example rmonitor_snapshot

ifeq ($(CCTOOLS_OPSYS),DARWIN)
	TARGETS =
	PROGRAMS =
else
	TARGETS = $(LIBRARIES) $(PROGRAMS)
endif

all: $(TARGETS) bindings

librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX): rmonitor_helper.o rmonitor_helper_comm.o
	$(CCTOOLS_CC) -shared -Wl,-init,rmonitor_helper_initialize -fPIC $^ -o $@ -ldl $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)

librminimonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX): rminimonitor_helper.o
	$(CCTOOLS_CC) -shared -Wl,-init,rmonitor_helper_initialize -fPIC $^ -o $@ -ldl $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)

piggybacker: piggybacker.o

rmonitor_piggyback.h: librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX) piggybacker
	./piggybacker rmonitor_piggyback.h librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX)

resource_monitor.o: resource_monitor.c rmonitor_piggyback.h

resource_monitor: resource_monitor.o rmonitor_helper_comm.o rmonitor_file_watch.o

rmonitor_snapshot: rmonitor_snapshot.o rmonitor_helper_comm.o

rmonitor_poll_example: rmonitor_poll_example.o

bindings:
	$(MAKE) -C bindings

lint:
	if ( ! clang-format -Werror --dry-run --style='file:../../.clang-format' $(SOURCES));\
		then\
		echo "========================================================";\
		echo "NOTICE: Run 'make format' to format your latest changes.";\
		echo "========================================================";\
		exit 1;\
	fi
	$(MAKE) -C bindings lint

format:
	clang-format -i $(SOURCES)

clean:
	rm -f $(OBJECTS) $(TARGETS) $(PROGRAMS) resource_monitor_pb.* rmonitor_piggyback.h* *.o
	$(MAKE) -C bindings clean

install: all
ifeq ($(CCTOOLS_OPSYS),DARWIN)
	$(MAKE) -C bindings install
else
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	$(MAKE) -C bindings install
endif

test: all

.PHONY: all clean install test lint format bindings

=== taskvine/src/examples/Makefile ===
include ../../../config.mk
include ../../../rules.mk

LOCAL_LINKAGE+=${CCTOOLS_HOME}/taskvine/src/manager/libtaskvine.a ${CCTOOLS_HOME}/dttools/src/libdttools.a
LOCAL_CCFLAGS+=-I ${CCTOOLS_HOME}/taskvine/src/manager

PROGRAMS = vine_example_gutenberg vine_example_blast vine_example_mosaic vine_example_watch vine_example_poncho
TARGETS = $(PROGRAMS)

all: $(TARGETS)

$(PROGRAMS): $(EXTERNALS)

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/cctools/examples/taskvine/C
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/cctools/examples/taskvine/python
	cp -r vine_example*.py script_example_for_poncho.py $(CCTOOLS_INSTALL_DIR)/doc/cctools/examples/taskvine/python
	for p in $(PROGRAMS); do cp $${p} $${p}.c $(CCTOOLS_INSTALL_DIR)/doc/cctools/examples/taskvine/C; done

clean:
	rm -rf $(PROGRAMS) *.o

test: all

lint:

format:

.PHONY: all clean install test lint format

=== taskvine/src/bindings/python3/Makefile ===
include ../../../../config.mk
include ../../../../rules.mk

# Python always uses 'so' for its modules (even on Darwin)
CCTOOLS_DYNAMIC_SUFFIX = so
# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
LOCAL_CCFLAGS = -w -fPIC -DNDEBUG $(CCTOOLS_PYTHON3_CCFLAGS) -I ../../manager
LOCAL_LINKAGE = $(CCTOOLS_PYTHON3_LDFLAGS) -lz $(CCTOOLS_OPENSSL_LDFLAGS) $(CCTOOLS_HOME)/taskvine/src/manager/libtaskvine.a $(CCTOOLS_HOME)/dttools/src/libdttools.a

CCTOOLS_FLAKE8_IGNORE_FILES = "cvine.py"

DSPYTHONSO = ndcctools/taskvine/_cvine.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = $(DSPYTHONSO)
OBJECTS = vine_wrap.o
TARGETS = $(LIBRARIES)

all: $(TARGETS)

vine_wrap.c: taskvine.i
	@echo "SWIG taskvine.i (python)"
	@$(CCTOOLS_SWIG) -o vine_wrap.c -outdir ndcctools/taskvine -python -I$(CCTOOLS_HOME)/dttools/src -I$(CCTOOLS_HOME)/taskvine/src/manager taskvine.i

$(DSPYTHONSO): vine_wrap.o $(EXTERNAL_DEPENDENCIES)

test:

lint:
	flake8 --ignore=$(CCTOOLS_FLAKE8_IGNORE_ERRORS) --exclude=$(CCTOOLS_FLAKE8_IGNORE_FILES) ndcctools/taskvine/

clean:
	rm -rf $(OBJECTS) $(TARGETS) ndcctools/taskvine/cvine.py vine_wrap.c vine_wrap.o *.pyc __pycache__

install: all
	mkdir -p $(CCTOOLS_PYTHON3_PATH)/ndcctools/taskvine
	cp ndcctools/taskvine/*.py $(DSPYTHONSO) $(CCTOOLS_PYTHON3_PATH)/ndcctools/taskvine
	cp taskvine.py $(CCTOOLS_PYTHON3_PATH)/

=== work_queue/src/bindings/python3/Makefile ===
include ../../../../config.mk
include $(CCTOOLS_HOME)/rules.mk

# Python always uses 'so' for its modules (even on Darwin)
CCTOOLS_DYNAMIC_SUFFIX = so
# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
LOCAL_CCFLAGS = -w -fPIC -DNDEBUG $(CCTOOLS_PYTHON3_CCFLAGS)
LOCAL_LINKAGE = $(CCTOOLS_PYTHON3_LDFLAGS) -lz $(CCTOOLS_OPENSSL_LDFLAGS)

EXTERNAL_DEPENDENCIES = $(CCTOOLS_HOME)/work_queue/src/libwork_queue.a $(CCTOOLS_HOME)/dttools/src/libdttools.a
WQPYTHONSO = ndcctools/_cwork_queue.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = $(WQPYTHONSO)
OBJECTS = work_queue_wrap.o
TARGETS = $(LIBRARIES)

all: $(TARGETS)

work_queue_wrap.c: work_queue.i
	@echo "SWIG work_queue.i (python)"
	@$(CCTOOLS_SWIG) -o work_queue_wrap.c -outdir ndcctools -python -I$(CCTOOLS_HOME)/dttools/src -I$(CCTOOLS_HOME)/work_queue/src work_queue.i

$(WQPYTHONSO): work_queue_wrap.o $(EXTERNAL_DEPENDENCIES)

test:

clean:
	rm -rf $(OBJECTS) $(TARGETS) ndcctools/cwork_queue.py work_queue_wrap.c *.pyc __pycache__

install: all
	mkdir -p $(CCTOOLS_PYTHON3_PATH)/ndcctools
	chmod 755 work_queue_example.py
	cp ndcctools/work_queue.py ndcctools/work_queue_display.py ndcctools/work_queue_dask.py ndcctools/cwork_queue.py $(WQPYTHONSO) $(CCTOOLS_PYTHON3_PATH)/ndcctools
	cp work_queue.py $(CCTOOLS_PYTHON3_PATH)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/cctools/doc/examples/work_queue/python
	cp work_queue_example.py $(CCTOOLS_INSTALL_DIR)/cctools/doc/examples/work_queue/python

=== debian/changelog ===
cctools (1:7.13.1-3) unstable; urgency=medium

  * Update sys_openat.patch to work on armel, armhf. Closes: #1088887
  * Add patch for 64-bit time typefix.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Dec 2024 06:59:00 +0000

cctools (1:7.13.1-2) unstable; urgency=medium

  * Update sys_openat.patch to work on armel, armhf

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 30 Nov 2024 18:58:55 +0000

cctools (1:7.13.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop old patches:
    - ccflags.patch
    - disable_doxygen
  * Patches:
    - cgi.patch. Closes: #1084664
    - shebang.patch for python3 paths
  * Change epoch to 1; 9.9 was an upstream error for 7.9.9 release
  * Fix broken vcs url
  * S-V: 4.7.0; no changes required
  * B-D on pkgconf not pkg-config
  * Drop B-D on libncurses5-dev
  * Ignore lintian soversion complaint on plugins

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Nov 2024 15:01:49 +0000

cctools (9.9-4) unstable; urgency=medium

  * Fix to build to correct globus configuration, enable broken
    non-default python build. Closes: #1057409, #1057400

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 06 Dec 2023 10:26:18 +0000

cctools (9.9-3) unstable; urgency=medium

  * Standards-Version: 4.6.2
  * Reproducible build: fix configure. Closes: #1025415
  * Build ok twice in a row. Closes: #1043670

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Aug 2023 12:38:54 +0100

cctools (9.9-2) unstable; urgency=medium

  * Don't try to build with golang support on arches where its not present

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 06 Sep 2021 19:45:43 +0100

cctools (9.9-1) unstable; urgency=medium

  * New upstream release
  * Ensure .gitignore files are not shipped in packages
  * Add golang support
  * Standards-Version: 4.6.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Aug 2021 13:38:58 +0100

=== debian/control ===
Source: cctools
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-sequence-python3,
  python3-all-dev, 
  python3-examples,
  libglobus-common-dev,
  default-libmysqlclient-dev,
  libfuse-dev,
  libext2fs-dev,
  libossp-uuid-dev,
  libperl-dev,
  libkrb5-dev,
  libsqlite3-dev,
  pkgconf,
  golang-go [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !sh4 !ia64 !alpha !hppa !m68k !powerpc !ppc64 !x32],
  libglobus-gss-assist-dev, net-tools, doxygen,
  libreadline6-dev | libreadline-dev | libeditreadline-dev, 
  libncurses-dev, 
  libjsonparser-dev,
  swig,
  m4, 
  mpi-default-dev
Standards-Version: 4.7.0
Homepage: https://ccl.cse.nd.edu/software/
Vcs-Browser: https://salsa.debian.org/neurodebian-team/cctools.git
Vcs-Git: https://salsa.debian.org/neurodebian-team/cctools.git -b debian/latest

Package: coop-computing-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Suggests: coop-computing-tools-doc, condor, gridengine-client
Description: cooperative computing tools
 This is a collection of software that help users to share resources in a
 complex, heterogeneous, and unreliable computing environment. This includes:
 .
  * Chirp: A personal filesystem and I/O protocol that allows unprivileged users
    to share space securely, efficiently, and conveniently. When combined
    with Parrot, Chirp allows users to create custom wide-area
    distributed filesystems.
  * Parrot: A transparent user-level virtual filesystem that allows any ordinary
    program to be attached to a remote storage device such as an FTP
    server or a Chirp server.
  * Makeflow: A workflow system for parallel and distributed computing that uses
    a language very similar to Make.
  * Work Queue: A system and API for building master-worker style programs that
    scale up to thousands of processors.
  * All Pairs: A computational abstraction for running very large Cartesian
    products.
  * Wavefront: A computational abstraction for running very large dynamic
    programming problems.
  * The Fault Tolerant Shell: A high-level programming language that allows
    users to combine the ease of shell scripting, the power of distributed
    programming, and the precision of compiled languages. Basically,
    parallel programming and exception handling for scripts.

Package: coop-computing-tools-dev
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries and header files for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides static libraries and header files for development.

Package: coop-computing-tools-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: documentation for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides the documentation (manual and API reference) in HTML
 format.

Package: python3-workqueue
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3
Description: cooperative computing tools work queue Python3 bindings
 CCTools's Work Queue is a system and API for building master-worker style
 programs that scale up to thousands of processors. This package provides
 bindings to access this system from Python3.

=== debian/rules ===
#!/usr/bin/make -f

non_default_python3_versions = $(shell python3 -c "print (\"`py3versions -v -s`\".replace(\"`py3versions -v -d`\", '').strip())")

export DH_VERBOSE=1

# one ring to rule them all ...
%:
	dh $@  --no-parallel

PY3:=$(shell py3versions -d)
CF:=$(shell dpkg-buildflags --get CFLAGS) 

ARCH_NOGOLANG:= hurd-i386 kfreebsd-amd64 kfreebsd-i386 sh4 ia64 alpha hppa m68k powerpc ppc64 x32
GOLANG:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NOGOLANG)),,--with-golang-path=/usr)

override_dh_auto_configure:
	# disable warning about unused results (necessary because warning is error
	# is ON)
	CFLAGS="$(CF) -I /usr/include/$(PY3) -DNDEBUG -Wno-unused-result" bash ./configure --with-globus-path=/usr \
		--prefix=/usr \
		$(GOLANG) \
		--with-krb5-path=/usr --with-readline-path=/usr \
		--with-mpi-path=/usr --with-fuse-path=/usr --with-zlib-path=/usr \
		--with-python3-path /usr/bin/python3 \
		--with-python2-path no \
		--without-system-parrot \
		--build-date "$(shell LC_ALL=C date --utc --date=@$${SOURCE_DATE_EPOCH})" 

override_dh_auto_test:
	# disable the tests for now on upstream's request. they will be reenabled
	# once the test suite can properly deal with the buildd environment

override_dh_auto_install:
	# copies needed for install to work
	cp work_queue/src/bindings/python3/work_queue_example.py work_queue/src/bindings/python3/work_queue.py
	cp chirp/src/bindings/python3/chirp_python_example.py chirp/src/bindings/python3/chirp.py
	dh_auto_install -- CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp 
	# make extensions for other supported python versions
	if [ -n "$(non_default_python3_versions)" ]; then \
		for pyver in $(non_default_python3_versions); do \
			CFLAGS="$(CF) -I /usr/include/python$${pyver} -DNDEBUG -Wno-unused-result" \
			bash ./configure --prefix --with-globus-path=/usr --with-krb5-path=/usr --with-readline-path=/usr \
				--with-mpi-path=/usr --with-fuse-path=/usr --with-zlib-path=/usr \
				--with-python3-path /usr/bin/python$${pyver} --with-python2-path no ; \
			make -B -C work_queue/src/bindings/python3 clean install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
			make -B -C resource_monitor/src clean install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp  ; \
			make -B -C chirp/src clean install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp  ; \
		done ; \
	fi
	# for now remove the 'apps' scripts till upstream confirms that the language
	# extension can be removed
	rm -f debian/tmp/bin/*.py
	find debian -name .gitignore -delete
	# fix permissions
	find debian/tmp/lib -name '*.py' -exec chmod 644 {} \;
	# remove undesired pieces
	-rm debian/tmp/doc/COPYING
	# upstream says it should not go into the page
	-rm debian/tmp/bin/watchdog
	# HDFS helpers are useless without HDFS in Debian
	-rm debian/tmp/bin/*_hdfs
	# newer doxygen puts jquery copy
	#-rm debian/tmp/doc/api/html/jquery.js
	$(MAKE) doc
	for v in vine_example_gutenberg vine_example_blast vine_example_poncho vine_example_mosaic vine_example_watch ; do \
		rm  debian/tmp/doc/cctools/examples/taskvine/C/$$v ; done
	find debian/tmp/ -type f -size 0 -delete 


override_dh_auto_clean:
	[ -e Makefile.config ] && dh_auto_clean || true
	-rm -f Makefile.config configure.rerun
	-rm -rf api hdfs-setup.template python/python-workqueue/setup.cfg
	# remove testrun left-overs
	-rm dttools/src/microbench dttools/src/work_queue_example
	-find $(CURDIR) -name '*.test.log' -delete
	-find $(CURDIR) -name '*_test' -delete
	-find $(CURDIR) -name '*.[ao]' -delete
	-find $(CURDIR) -name '*.so' -delete
	find doc/man/md/ -name '*.md' -delete
	find doc/man/ -name '*.1' -delete
	find doc/man -name '*.html' -delete
	-rm -f work_queue/src/work_queue_example work_queue/src/work_queue_example_json work_queue/src/work_queue_status
	-rm -f work_queue/src/work_queue_test_watch resource_monitor/src/rmonitor_snapshot work_queue/src/work_queue_worker
	-rm -f work_queue/src/work_queue_server resource_monitor/src/resource_monitor resource_monitor/src/rmonitor_poll_example
	-rm -f batch_job/src/work_queue_factory resource_monitor/src/piggybacker makeflow/src/makeflow_mpi_submitter
	-rm -rf sand/test/filter_verification/random.cand.filter.tmp/
	-rm -rf sand/test/test_20.cand.filter.tmp/
	-rm -f sand/test/test_20.cand sand/test/test_20.cfa sand/test/*.log
	-rm -rf makeflow/test/input/ makeflow/test/worker.pid
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.makeflowlog
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.wqlog
	-rm -rf makeflow/test/src/
	-rm dttools/src/multirun sand/test/banded.log makeflow/src/makeflow makeflow/src/makeflow_viz batch_job/src/work_queue_pool
	-rm -f makeflow/src/makeflow_mpi_starter makeflow/src/makeflow_analyze grow/src/grow_fuse dttools/src/jx_repl
	-rm -f chirp/src/chirp dttools/src/catalog_update dttools/src/env_replace makeflow/src/makeflow_linker
	-rm -f makeflow/src/makeflow_status dttools/src/jx2env dttools/src/jx2json dttools/src/watchdog ftp_lite/src/ftp_lite_copy
	-rm -f chirp/src/chirp_benchmark deltadb/src/deltadb_upgrade_log dttools/src/disk_allocator deltadb/src/deltadb_query
	-rm -f chirp/src/chirp_distribute chirp/src/chirp_status dataswarm/worker/ds_worker deltadb/src/catalog_server dttools/src/catalog_query
	-rm -f dataswarm/manager/ds_manager chirp/src/chirp_stream_files chirp/src/confuga_adm chirp/src/chirp_fuse chirp/src/chirp_get
	-rm -f chirp/src/chirp_put chirp/src/chirp_server chirp/src/bindings/python3/Python.framework
	-rm -f work_queue/src/bindings/python3/Python.framework work_queue/src/sge_submit_workers
	for d in chirp/src/bindings/perl/CChirp.pm chirp/src/bindings/perl/chirp_wrap.c chirp/src/bindings/python3/CChirp.py \
 		chirp/src/bindings/python3/Chirp.py chirp/src/bindings/python3/chirp_wrap.c config.mk \
		doc/api/html/chirp_client_perl.html doc/api/html/chirp_stat_perl.html doc/api/html/work_queue_perl.html	\
 		doc/api/html/work_queue_task_perl.html resource_monitor/src/bindings/python3/resource_monitor.py \
		resource_monitor/src/bindings/python3/rmonitor_wrap.c resource_monitor/src/rmonitor_piggyback.h \
 		work_queue/src/bindings/perl/work_queue.pm work_queue/src/bindings/perl/work_queue_wrap.c \
		work_queue/src/bindings/python3/work_queue.py work_queue/src/bindings/python3/work_queue_wrap.c ; \
		do rm -f $$d ; done

## cctools 7.14.5

=== Makefile ===
--- 
+++ 
@@ -61,6 +61,9 @@
 	@$(MAKE) -C $(@:format-%=%) format
 format: $(FORMAT_PACKAGES)
 
+doc_serve:
+	mkdocs serve -f doc/mkdocs.yml
+
 rpm:
 	./packaging/rpm/rpm_creator.sh $(RPM_VERSION) $(RPM_RELEASE)

=== dttools/src/Makefile ===
include ../../config.mk
include ../../rules.mk

SOURCES = \
	address.c \
	auth.c \
	auth_address.c \
	auth_all.c \
	auth_globus.c \
	auth_hostname.c \
	auth_kerberos.c \
	auth_ticket.c \
	auth_unix.c \
	b64.c \
	bitmap.c \
	bucketing.c \
	bucketing_exhaust.c \
	bucketing_greedy.c \
	bucketing_manager.c \
	buffer.c \
	catalog_query.c \
	category.c \
	cctools.c \
	cctools_endian.c \
	change_process_title.c \
	chunk.c \
	clean_dir.c \
	compat-at.c \
	console_login.c \
	copy_stream.c \
	copy_tree.c \
	create_dir.c \
	daemon.c \
	datagram.c \
	debug.c \
	debug_file.c \
	debug_journal.c \
	debug_stream.c \
	debug_syslog.c \
	disk_alloc.c \
	domain_name.c \
	domain_name_cache.c \
	dpopen.c \
	elfheader.c \
	envtools.c \
	fast_popen.c \
	fd.c \
	file_cache.c \
	file_link_recursive.c \
	full_io.c \
	get_canonical_path.c \
	get_line.c \
	getopt.c \
	getopt_aux.c \
	gpu_info.c \
	hash_cache.c \
	hash_table.c \
	hdfs_library.c \
	histogram.c \
	hmac.c \
	host_disk_info.c \
	host_memory_info.c \
	http_query.c \
	interfaces_address.c \
	itable.c \
	jx.c \
	jx_binary.c\
	jx_getopt.c \
	jx_match.c \
	jx_parse.c \
	jx_print.c \
	jx_pretty_print.c \
	jx_canonicalize.c \
	jx_table.c \
	jx_eval.c \
	jx_sub.c \
	jx_function.c \
	link.c \
	link_auth.c \
	list.c \
	load_average.c \
	md5.c \
	memfdexe.c \
	mkdir_recursive.c \
	twister.c \
	nvpair.c \
	nvpair_jx.c \
	password_cache.c \
	path.c \
	path_disk_size_info.c \
	pattern.c \
	ppoll_compat.c \
	preadwrite.c \
	process.c \
	random.c \
	rmonitor.c \
	rmonitor_poll.c \
	rmsummary.c \
	set.c \
	semaphore.c \
	sha1.c \
	shell.c \
	sh_popen.c\
	sigdef.c \
	sleeptools.c \
	sort_dir.c \
	stats.c \
	string_array.c \
	stringtools.c \
	string_set.c \
	text_array.c \
	text_list.c \
	timer.c \
	timestamp.c \
	tlq_config.c \
	trash.c \
	unlink_recursive.c \
	uptime.c \
	url_encode.c \
	username.c \
	uuid.c \
	xxmalloc.c \

HEADERS_PUBLIC = \
	auth.h \
	auth_address.h \
	auth_all.h \
	auth_globus.h \
	auth_hostname.h \
	auth_kerberos.h \
	auth_ticket.h \
	auth_unix.h \
	bitmap.h \
	bucketing.h \
	bucketing_exhaust.h \
	bucketing_greedy.h \
	bucketing_manager.h \
	buffer.h \
	category.h \
	cctools.h \
	copy_tree.h \
	compat-at.h \
	debug.h \
	envtools.h \
	fast_popen.h \
	file_link_recursive.h \
	full_io.h \
	getopt.h \
	getopt_aux.h \
	hash_table.h \
	histogram.h \
	host_memory_info.h \
	http_query.h \
	int_sizes.h \
	itable.h \
	jx.h \
	jx_match.h \
	link.h \
	list.h \
	load_average.h \
	md5.h \
	macros.h \
	path.h \
	rmonitor_poll.h \
	rmsummary.h \
	stringtools.h \
	text_array.h \
	text_list.h \
	timestamp.h \
	unlink_recursive.h \
	xxmalloc.h \

LIBRARIES = libdttools.a

ifneq ($(CCTOOLS_STATIC),1)
PRELOAD_LIBRARIES = libforce_halt_enospc.so
endif

ifeq ($(CCTOOLS_CURL_AVAILABLE),yes)
CCTOOLS_EXTERNAL_LINKAGE += $(CCTOOLS_CURL_LDFLAGS) -lssl -lcrypto
SOURCES += s3_file_io.c
HEADERS_PUBLIC += s3_file_io.h
endif

OBJECTS = $(SOURCES:%.c=%.o)

#separate, because catalog_query has a slightly different order of linking.
MOST_PROGRAMS = catalog_update watchdog disk_allocator jx2json jx2env jx_repl env_replace
PROGRAMS = $(MOST_PROGRAMS) catalog_query

SCRIPTS = cctools_gpu_autodetect
TARGETS = $(LIBRARIES) $(PRELOAD_LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS)
TEST_PROGRAMS = auth_test disk_alloc_test jx_test microbench multirun jx_count_obj_test jx_canonicalize_test jx_merge_test hash_table_offset_test hash_table_fromkey_test histogram_test category_test jx_binary_test bucketing_base_test bucketing_manager_test

all: $(TARGETS) catalog_query

libdttools.a: $(OBJECTS)

$(MOST_PROGRAMS) $(TEST_PROGRAMS): libdttools.a

jx_parse.o: jx_parse.c
	$(CCTOOLS_CC) -O3 -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $<

jx.o: jx.c
	$(CCTOOLS_CC) -O3 -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $<

jx_repl: jx_repl.o libdttools.a
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS)

catalog_query: catalog_query.o catalog_query_tool.o libdttools.a

auth_globus.o: auth_globus.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_GLOBUS_CCFLAGS) $<

auth_test: auth_test.o libdttools.a
ifeq ($(CCTOOLS_STATIC),1)
	@echo "auth_test currently cannot be build statically."
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)
endif

libforce_halt_enospc.so: libforce_halt_enospc.o
	$(CCTOOLS_CC) -shared -fPIC $^ -o $@ -ldl

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(SCRIPTS) $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(PRELOAD_LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(HEADERS_PUBLIC) $(CCTOOLS_INSTALL_DIR)/include/cctools/

test: all

lint:
		if ( ! clang-format -Werror --dry-run --style='file:../../.clang-format' $(SOURCES));\
		then\
				echo  "========================================================";\
				echo  "NOTICE: Run `make format` to format your latest changes.";\
				echo  "========================================================";\
				exit 1;\
		fi

format:
		clang-format -i $(SOURCES)


.PHONY: all clean install test

# vim: set noexpandtab tabstop=4:

=== resource_monitor/src/Makefile ===
--- 
+++ 
@@ -20,11 +20,11 @@
 
 PROGRAMS = resource_monitor piggybacker rmonitor_poll_example rmonitor_snapshot
 
-ifeq ($(CCTOOLS_OPSYS),DARWIN)
+ifeq ($(CCTOOLS_LINUX_NATIVE_X86_64),yes)
+	TARGETS = $(LIBRARIES) $(PROGRAMS)
+else
 	TARGETS =
 	PROGRAMS =
-else
-	TARGETS = $(LIBRARIES) $(PROGRAMS)
 endif
 
 all: $(TARGETS) bindings
@@ -69,13 +69,13 @@
 	$(MAKE) -C bindings clean
 
 install: all
-ifeq ($(CCTOOLS_OPSYS),DARWIN)
-	$(MAKE) -C bindings install
-else
+ifeq ($(CCTOOLS_LINUX_NATIVE_X86_64),yes)
 	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
 	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
 	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
 	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
+	$(MAKE) -C bindings install
+else
 	$(MAKE) -C bindings install
 endif

=== taskvine/src/Makefile ===
include ../../config.mk
include ../../rules.mk

TARGETS=manager worker tools bindings examples

all: $(TARGETS)

worker: manager
bindings: manager
tools: manager
examples: manager worker tools bindings

$(TARGETS): %:
	$(MAKE) -C $@ $(MAKECMDGOALS)

install:
	for d in $(TARGETS); do $(MAKE) -C $$d install; done

clean:
	for d in $(TARGETS); do $(MAKE) -C $$d clean; done

lint: $(TARGETS)

format: $(TARGETS)

.PHONY: all clean install test lint format $(TARGETS)

=== work_queue/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# Note that this list of sources only contains
# the items that go into libwork_queue.a, to
# avoid polluting user programs with our internal code.

SOURCES_LIBRARY = \
	work_queue.c \
	work_queue_catalog.c \
	work_queue_resources.c

SOURCES_WORKER = \
	work_queue_sandbox.o \
	work_queue_cache.o \
	work_queue_process.o \
	work_queue_coprocess.o \
	work_queue_watcher.o \
	work_queue_gpus.o

PUBLIC_HEADERS = work_queue.h

LIBDTTOOLS = ${CCTOOLS_HOME}/dttools/src/libdttools.a
EXTERNALS = $(LIBDTTOOLS)
EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libwork_queue.a
OBJECTS = $(OBJECTS_LIBRARY) $(OBJECTS_WORKER) work_queue_test_main.o
OBJECTS_LIBRARY = $(SOURCES_LIBRARY:%.c=%.o)
OBJECTS_WORKER = $(SOURCES_WORKER:%.c=%.o)
PROGRAMS = work_queue_worker work_queue_status work_queue_example
PUBLIC_HEADERS = work_queue.h work_queue_catalog.h
SCRIPTS = work_queue_submit_common condor_submit_workers uge_submit_workers torque_submit_workers pbs_submit_workers slurm_submit_workers work_queue_graph_log work_queue_graph_workers
TEST_PROGRAMS = work_queue_example work_queue_test work_queue_test_watch work_queue_priority_test
TARGETS = $(LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS) uge_submit_workers bindings

all: $(TARGETS)

libwork_queue.a: $(OBJECTS_LIBRARY)
work_queue_test work_queue_test_watch: work_queue_test_main.o
work_queue_worker: $(OBJECTS_WORKER)
$(PROGRAMS) $(TEST_PROGRAMS): libwork_queue.a $(EXTERNAL_DEPENDENCIES)

bindings: libwork_queue.a work_queue.i $(EXTERNAL_DEPENDENCIES)
	@$(MAKE) -C bindings

uge_submit_workers: uge_submit_workers_common
	sed -e "s/SGE_CUSTOM_PARAMETERS/${CCTOOLS_SGE_PARAMETERS}/" $< > $@
	chmod 755 $@

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/cctools/examples/work_queue/C
	cp work_queue_example.c $(CCTOOLS_INSTALL_DIR)/doc/cctools/examples/work_queue/C
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	@$(MAKE) -C bindings install

clean:
	rm -rf $(OBJECTS) $(LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS) *.o uge_submit_workers
	@$(MAKE) -C bindings clean

test: all

.PHONY: all clean install test bindings

=== devel/prune/src/Makefile ===
include ../../../config.mk
include ../../../rules.mk

all: prune_worker #prune_server


prune_worker: prune_worker.py
	sed 's%CCTOOLS_VERSION%${CCTOOLS_VERSION}%' < prune_worker.py | sed 's%CCTOOLS_RELEASE_DATE%${CCTOOLS_RELEASE_DATE}%' > prune_worker
	chmod 755 prune_worker

clean:
	rm -f prune_worker #prune_server

install: prune_worker
	#cp prune_server ${CCTOOLS_INSTALL_DIR}/bin/prune_server
	mv prune_worker ${CCTOOLS_INSTALL_DIR}/bin/prune_worker
	mkdir -p $(CCTOOLS_PYTHON_PATH)/prune
	cp -r prune/* $(CCTOOLS_PYTHON_PATH)/prune

=== devel/umbrella/src/Makefile ===
include ../../../config.mk
include ../../../rules.mk

EXTERNAL_DEPENDENCIES =
LIBRARIES =
OBJECTS =
PROGRAMS = umbrella
SCRIPTS =
TARGETS = $(PROGRAMS) $(LIBRARIES) umbrella_helper.html

all: $(TARGETS)

umbrella: umbrella.py
	sed 's%CCTOOLS_VERSION%${CCTOOLS_VERSION}%' < umbrella.py > umbrella
	chmod 755 umbrella

umbrella_helper.html: umbrella.py
	@if $(CCTOOLS_PYDOC) -w umbrella > /dev/null 2>&1; then mv umbrella.html umbrella_helper.html; else echo Could not create $@; fi

clean:
	rm -f $(OBJECTS) $(TARGETS)

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/cctools/umbrella
	if [ -f umbrella_helper.html ]; then cp umbrella_helper.html $(CCTOOLS_INSTALL_DIR)/doc/cctools/umbrella; fi

test: all

.PHONY: all clean install test

=== taskvine/src/manager/Makefile ===
include ../../../config.mk
include ../../../rules.mk

SOURCES = \
	vine_manager.c \
	vine_manager_get.c \
	vine_manager_put.c \
	vine_manager_factory.c \
	vine_manager_summarize.c \
	vine_schedule.c \
	vine_worker_info.c \
	vine_catalog.c \
	vine_counters.c \
	vine_resources.c \
	vine_task.c \
	vine_file.c \
	vine_mount.c \
	vine_txn_log.c \
	vine_taskgraph_log.c \
	vine_cached_name.c \
	vine_checksum.c \
	vine_perf_log.c \
	vine_file_replica.c \
	vine_factory_info.c \
	vine_task_info.c \
	vine_blocklist.c \
	vine_current_transfers.c \
	vine_file_replica_table.c \
	vine_fair.c \
	vine_runtime_dir.c

PUBLIC_HEADERS = taskvine.h

OBJECTS = $(SOURCES:%.c=%.o)
PUBLIC_HEADERS = taskvine.h
LIBRARIES = libtaskvine.a
TARGETS = $(LIBRARIES)

all: $(TARGETS)

libtaskvine.a: $(OBJECTS)

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/

clean:
	rm -rf $(OBJECTS) $(LIBRARIES)

test: all

lint:
	if ( ! clang-format -Werror --dry-run --style='file:../../../.clang-format' $(SOURCES));\
	then\
		echo  "========================================================";\
		echo  "NOTICE: Run `make format` to format your latest changes.";\
		echo  "========================================================";\
		exit 1;\
	fi

format:
	clang-format -i $(SOURCES)

.PHONY: all clean install test lint format

=== debian/changelog ===
cctools (1:7.14.5-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 21:58:33 +0000

cctools (1:7.14.5-1) unstable; urgency=medium

  * New upstream release
  * Now build-dep on libfuse3-dev
  * Drop kfreebsd, ia64

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 18 Feb 2025 14:56:38 +0000

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 PY3:=$(shell py3versions -d)
 CF:=$(shell dpkg-buildflags --get CFLAGS) 
 
-ARCH_NOGOLANG:= hurd-i386 kfreebsd-amd64 kfreebsd-i386 sh4 ia64 alpha hppa m68k powerpc ppc64 x32
+ARCH_NOGOLANG:= hurd-i386 sh4 alpha hppa m68k powerpc ppc64 x32
 GOLANG:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NOGOLANG)),,--with-golang-path=/usr)
 
 override_dh_auto_configure:

## cctools 7.15.9

=== Makefile ===
--- 
+++ 
@@ -55,7 +55,7 @@
 	@$(MAKE) -C $(@:lint-%=%) lint
 lint: $(LINT_PACKAGES)
 
-PACKAGES_TO_FORMAT = taskvine resource_monitor batch_job dttools
+PACKAGES_TO_FORMAT = taskvine resource_monitor batch_job dttools devel/pledge
 FORMAT_PACKAGES = $(PACKAGES_TO_FORMAT:%=format-%)
 $(FORMAT_PACKAGES): config.mk
 	@$(MAKE) -C $(@:format-%=%) format

=== doc/Makefile ===
include ../config.mk

all: ${CCTOOLS_DOCTARGETS}

htmlpages manpages mdpages:
	$(MAKE) -C man $@

apiperl: manuals/api/html/work_queue_perl.html manuals/api/html/work_queue_task_perl.html manuals/api/html/chirp_client_perl.html manuals/api/html/chirp_stat_perl.html

apipages: manuals/api/html/index.html

manuals/api/html/index.html:
	mkdir -p manuals/api/html
	doxygen api/cctools.doxygen.config

manuals/api/html/work_queue_perl.html:
	mkdir -p manuals/api/html
	pod2html ../work_queue/src/bindings/perl/Work_Queue.pm > $@
	@rm -f pod2htm*.tmp

manuals/api/html/work_queue_task_perl.html:
	mkdir -p manuals/api/html
	pod2html ../work_queue/src/bindings/perl/Work_Queue/Task.pm > $@
	@rm -f pod2htm*.tmp

manuals/api/html/chirp_client_perl.html:
	mkdir -p manuals/api/html
	pod2html ../chirp/src/bindings/perl/Chirp/Client.pm > $@
	@rm -f pod2htm*.tmp

manuals/api/html/chirp_stat_perl.html:
	mkdir -p manuals/api/html
	pod2html ../chirp/src/bindings/perl/Chirp/Stat.pm > $@
	@rm -f pod2htm*.tmp


install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/cctools
	cp -a manuals $(CCTOOLS_INSTALL_DIR)/doc/cctools
	$(MAKE) -C man install

test:

clean:
	rm -rf manuals/api *~
	$(MAKE) -C man clean

.PHONY: all clean install test

=== batch_job/src/Makefile ===
--- 
+++ 
@@ -25,7 +25,8 @@
 	batch_queue_work_queue.c \
 	batch_queue_cluster.c \
 	batch_queue_k8s.c \
-	batch_queue_amazon.c
+	batch_queue_amazon.c \
+	batch_queue_flux.c
 
 PUBLIC_HEADERS = batch_queue.h batch_job.h batch_job_info.h batch_file.h batch_wrapper.h

=== chirp/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# Globus is needed by all executables via libdttools.a/auth_globus.o
LOCAL_LINKAGE = $(CCTOOLS_GLOBUS_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libchirp.a
OBJECTS = chirp_tool.o chirp_fuse.o $(OBJECTS_LIBRARY) $(OBJECTS_SERVER) $(OBJECTS_PROGRAMS)
OBJECTS_LIBRARY = $(SOURCES_LIBRARY:%.c=%.o)
OBJECTS_SERVER = $(SOURCES_SERVER:%.c=%.o)
OBJECTS_PROGRAMS = $(PROGRAMS:%=%.o)
PROGRAMS = $(PROGRAMS_CHIRP)
PROGRAMS_CHIRP = chirp chirp_get chirp_put chirp_server chirp_status chirp_benchmark chirp_stream_files chirp_fuse chirp_distribute
PUBLIC_HEADERS = chirp_global.h chirp_multi.h chirp_reli.h chirp_client.h chirp_stream.h chirp_protocol.h chirp_matrix.h chirp_types.h chirp_recursive.h
SCRIPTS = chirp_audit_cluster chirp_server_hdfs
SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c
SOURCES_SERVER = chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_job.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_chirp.c
TARGETS = $(PROGRAMS) $(LIBRARIES)

all: $(TARGETS) bindings

chirp: chirp_tool.o
ifeq ($(CCTOOLS_STATIC),1)
	$(CCTOOLS_LD) -static -g -o $@ $(LOCAL_LINKAGE) $^ $(CCTOOLS_STATIC_LINKAGE)
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS)
endif

ifeq ($(CCTOOLS_STATIC),1)
chirp_fuse:
	@echo "chirp_fuse cannot be built statically"
else
chirp_fuse: chirp_fuse.o
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_FUSE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

chirp_fuse.o: chirp_fuse.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_FUSE_CCFLAGS) $<
endif

# This is the library intended to be used by clients of the system.
libchirp.a: $(OBJECTS_LIBRARY)

chirp_server: $(OBJECTS_SERVER)
$(PROGRAMS_CHIRP): libchirp.a $(EXTERNAL_DEPENDENCIES)

bindings: chirp_swig_wrap.o libchirp.a $(EXTERNAL_DEPENDENCIES)
	@$(MAKE) -C bindings

clean:
	rm -f $(OBJECTS) $(TARGETS)
	@$(MAKE) -C bindings clean

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	if [ -f $(CCTOOLS_INSTALL_DIR)/bin/chirp_server ]; then mv $(CCTOOLS_INSTALL_DIR)/bin/chirp_server $(CCTOOLS_INSTALL_DIR)/bin/chirp_server.old; fi
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
	cp -r ../tools/workflows/ $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
	@$(MAKE) -C bindings install

test: all
	@$(MAKE) -C bindings test

.PHONY: all clean install test bindings

=== deltadb/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libdeltadb.a
OBJECTS = $(SOURCES:%.c=%.o)
PROGRAMS = deltadb_query deltadb_upgrade_log catalog_server
SCRIPTS =
SOURCES = deltadb.c deltadb_query.c deltadb_stream.c deltadb_reduction.c
TARGETS = $(LIBRARIES) $(PROGRAMS)

all: $(TARGETS)

libdeltadb.a: $(OBJECTS)

deltadb_query: deltadb_query_main.o libdeltadb.a $(EXTERNAL_DEPENDENCIES)

deltadb_upgrade_log: deltadb_upgrade_log.o libdeltadb.a $(EXTERNAL_DEPENDENCIES)

catalog_server: catalog_server.o catalog_export.o libdeltadb.a $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin

test: all

.PHONY: all clean install test

=== devel/apps/Makefile ===
include ../../config.mk
include ../../rules.mk

PHONY_TARGETS = wq_replica_exchange
SCRIPTS = makeflow_blast/makeflow_blast makeflow_bwa/makeflow_bwa makeflow_gatk/makeflow_gatk makeflow_blasr/makeflow_blasr wq_maker/wq_maker

all:

install:
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/

doc:

clean:

test:

=== devel/nopen/Makefile ===
include ../../config.mk

TARGETS=    lib-nopen.so

all:		$(TARGETS)

clean:
	rm -f $(TARGETS) *.o

lib-nopen.so:	lib-nopen.o
	$(LD) $(LDFLAGS) -shared -o $@ $^

lib-nopen.o: lib-nopen.c lib-nopen.h
	$(CC) $(CFLAGS) -fPIC -c -o lib-nopen.o lib-nopen.c

=== devel/pledge/Makefile ===
include ../../config.mk
include ../../rules.mk

PHONY_TARGETS ?= src
TARGETS ?= $(PHONY_TARGETS)

all: $(TARGETS)

$(TARGETS):
	@$(MAKE) -C $@

CLEAN_TARGETS = $(TARGETS:%=clean-%)
$(CLEAN_TARGETS):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_TARGETS)

LINT_TARGETS = $(TARGETS:%=lint-%)
$(LINT_TARGETS):
	@$(MAKE) -C $(@:lint-%=%) lint
lint: $(LINT_TARGETS)

FORMAT_TARGETS = $(TARGETS:%=format-%)
$(FORMAT_TARGETS):
	@$(MAKE) -C $(@:format-%=%) format
format: $(FORMAT_TARGETS)

INSTALL_TARGETS = $(TARGETS:%=install-%)
$(INSTALL_TARGETS):
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_TARGETS)

TEST_TARGETS = $(TARGETS:%=test-%)
$(TEST_TARGETS):
	@$(MAKE) -C $(@:test-%=%) test
test: $(TEST_TARGETS)


.PHONY: $(PHONY_TARGETS) $(CLEAN_TARGETS) $(INSTALL_TARGETS) $(TEST_TARGETS) all clean install test

=== devel/prune/Makefile ===
include ../../config.mk
include ../../rules.mk

PHONY_TARGETS ?= src
TARGETS ?= $(PHONY_TARGETS)

all: $(TARGETS)

$(TARGETS):
	@$(MAKE) -C $@

CLEAN_TARGETS = $(TARGETS:%=clean-%)
$(CLEAN_TARGETS):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_TARGETS)

INSTALL_TARGETS = $(TARGETS:%=install-%)
$(INSTALL_TARGETS):
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_TARGETS)

TEST_TARGETS = $(TARGETS:%=test-%)
$(TEST_TARGETS):
	@$(MAKE) -C $(@:test-%=%) test
test: $(TEST_TARGETS)

.PHONY: $(PHONY_TARGETS) $(CLEAN_TARGETS) $(INSTALL_TARGETS) $(TEST_TARGETS) all clean install test

=== devel/tlq/Makefile ===
all: client

client: ../dttools/src/jx_test
	cp ../dttools/src/jx_test client
	
clean:
	@echo Cleaning TLQ installation.
	cd client && rm -rf .tlq_session.log deposits.log jx_test

install:

.PHONY: all clean install

# vim: set noexpandtab tabstop=4:

=== doc/man/Makefile ===
include ../../config.mk

SOURCES=${shell find m4 -type f -name '*.m4' -print}

MDFILES   = ${SOURCES:m4/%.m4=md/%.md}
HTMLFILES = ${SOURCES:m4/%.m4=html/%.html}
TXTFILES  = ${SOURCES:m4/%.m4=txt/%.txt}
PDFFILES  = ${SOURCES:m4/%.m4=pdf/%.pdf}
MANFILES  = ${SOURCES:m4/%.m4=man/%.1}
ZIPFILES  = ${MANFILES:man/%.m4=man/%.1.gz}

all: ${CCTOOLS_DOCTARGETS}

apipages:

mdpages: ${MDFILES}

htmlpages: ${HTMLFILES}

manpages: ${ZIPFILES}

md/%.md: m4/%.m4
	mkdir -p md
	m4 -DMD ${CCTOOLS_M4_ARGS} $< > $@

html/%.html: m4/%.m4
	mkdir -p html
	m4 -DHTML ${CCTOOLS_M4_ARGS} $< > $@

man/%.1: m4/%.m4
	mkdir -p man
	m4 -DMAN ${CCTOOLS_M4_ARGS} $< > $@

man/%.gz: man/%.1
	mkdir -p man
	gzip < $< > $@

txt/%.txt: man/%.1
	mkdir -p txt
	nroff -man $< > $@

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/cctools
	mkdir -p $(CCTOOLS_INSTALL_DIR)/man
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/man/man1
	if [ -f man/chirp.1.gz ]; then cp man/*.1.gz $(CCTOOLS_INSTALL_DIR)/share/man/man1; fi
	if [ -f html ]; then cp -r html $(CCTOOLS_INSTALL_DIR)/doc/man/; fi

test:

clean:
	rm -rf $(HTMLFILES) $(MANFILES) $(ZIPFILES) *~

.PHONY: all clean install test

=== dttools/src/Makefile ===
--- 
+++ 
@@ -91,6 +91,8 @@
 	pattern.c \
 	ppoll_compat.c \
 	preadwrite.c \
+	priority_queue.c \
+	priority_queue_test.c \
 	process.c \
 	random.c \
 	rmonitor.c \
@@ -161,6 +163,7 @@
 	md5.h \
 	macros.h \
 	path.h \
+	priority_queue.h \
 	rmonitor_poll.h \
 	rmsummary.h \
 	stringtools.h \
@@ -190,7 +193,7 @@
 
 SCRIPTS = cctools_gpu_autodetect
 TARGETS = $(LIBRARIES) $(PRELOAD_LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS)
-TEST_PROGRAMS = auth_test disk_alloc_test jx_test microbench multirun jx_count_obj_test jx_canonicalize_test jx_merge_test hash_table_offset_test hash_table_fromkey_test histogram_test category_test jx_binary_test bucketing_base_test bucketing_manager_test
+TEST_PROGRAMS = auth_test disk_alloc_test jx_test microbench multirun jx_count_obj_test jx_canonicalize_test jx_merge_test hash_table_offset_test hash_table_fromkey_test hash_table_benchmark histogram_test category_test jx_binary_test bucketing_base_test bucketing_manager_test priority_queue_test
 
 all: $(TARGETS) catalog_query

=== debian/changelog ===
cctools (1:7.15.9-1) unstable; urgency=medium

  * New upstream release
  * Update d/copyright; thanks lintian
  * Standards-Version: 4.7.2
  * Patch for reproducible builds thanks to Chris Lamb. Closes: #1108281
  * Drop obsolete bug. Closes: #1084461

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 02 Oct 2025 13:41:18 +0100

=== debian/control ===
--- 
+++ 
@@ -8,14 +8,14 @@
   python3-examples,
   libglobus-common-dev,
   default-libmysqlclient-dev,
-  libfuse-dev,
+  libfuse3-dev,
   libext2fs-dev,
   libossp-uuid-dev,
   libperl-dev,
   libkrb5-dev,
   libsqlite3-dev,
   pkgconf,
-  golang-go [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !sh4 !ia64 !alpha !hppa !m68k !powerpc !ppc64 !x32],
+  golang-go [!hurd-i386 !sh4 !alpha !hppa !m68k !powerpc !ppc64 !x32],
   libglobus-gss-assist-dev, net-tools, doxygen,
   libreadline6-dev | libreadline-dev | libeditreadline-dev, 
   libncurses-dev, 
@@ -23,7 +23,7 @@
   swig,
   m4, 
   mpi-default-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://ccl.cse.nd.edu/software/
 Vcs-Browser: https://salsa.debian.org/neurodebian-team/cctools.git
 Vcs-Git: https://salsa.debian.org/neurodebian-team/cctools.git -b debian/latest

=== debian/rules ===
--- 
+++ 
@@ -66,6 +66,10 @@
 	for v in vine_example_gutenberg vine_example_blast vine_example_poncho vine_example_mosaic vine_example_watch ; do \
 		rm  debian/tmp/doc/cctools/examples/taskvine/C/$$v ; done
 	find debian/tmp/ -type f -size 0 -delete 
+	# fix nondeterminstic lines
+	sed -i '/^# Generated at.*/d' ./debian/tmp/etc/cctools/config.mk
+	sed -i -e 's@$(CURDIR)@/usr/share/cctools@g' ./debian/tmp/etc/cctools/config.mk
+ 
 
 
 override_dh_auto_clean:
